import json

from web3 import  Web3

import flask
from flask import jsonify

app = flask.Flask(__name__)


@app.route('/web3/send_transaction', methods=['POST'])
def send_transaction():
    data = flask.request.json

    acct2_addr = data['grantNftTo']
    nftId = int(data['nftId'])

    acct1_addr = "0x445abeA31F362D6D99Ba337D8CA4824B25548c88"
    #acct2_addr = "0x46826Eb0068d12baBde52d6bdD83631881ebCE9f"

    #test_addr = "0x910190EfABFc57b491ca8750D08F8993888F5474"

    provider = "https://bsc-dataseed3.defibit.io"

    w3 = Web3(Web3.HTTPProvider(provider))

    pk = "7c2f030c0cffc1d463ccb949a298a1e35509ab48bafb2291e6d29c6fcdb2bc79"

    #acct1 = w3.eth.account.from_key(acct1_addr)
    acct1 = w3.eth.account.from_key(pk)

    contractAddress= "0x46826Eb0068d12baBde52d6bdD83631881ebCE9f"

    contractAddress = w3.to_checksum_address(contractAddress)

    with open("abi.json") as f:
        abi = json.load(f)

    contract = w3.eth.contract(address=contractAddress, abi=abi)

    # encode abi for transfer function
    transfer_data = contract.encodeABI(fn_name = "safeMint", args=[acct2_addr, nftId])

    transaction = {
        'to': contractAddress,
        'value': Web3.to_hex(0),
        'nonce': Web3.to_hex(w3.eth.get_transaction_count(acct1_addr)),
        'gas': Web3.to_hex(2000000),
        'gasPrice': Web3.to_hex(w3.eth.gas_price),
        'chainId': Web3.to_hex(56),
        'data': transfer_data
    }

    signed = w3.eth.account.sign_transaction(transaction, pk)

    tx_hash = w3.eth.send_raw_transaction(Web3.to_hex(signed.rawTransaction))
    tx = w3.eth.get_transaction(tx_hash)
    if not tx["from"] == acct1_addr:
        return "Transaction failed", 400

    return jsonify(w3.to_json(tx)), 200

if __name__ == '__main__':
    app.run(host="0.0.0.0")
